---
# tasks file for zero-app-minio
- name: Provision Rancher
  block:
    - name: Add Helm Repo
      command: helm repo add rancher-latest https://releases.rancher.com/server-charts/latest

    - name: Check for Cattle Namespace
      command: kubectl get namespace cattle-system
      register: cattle_namespace
      ignore_errors: True
    
    - name: Add Cattle Namespace
      command: kubectl create namespace cattle-system
      when: cattle_namespace.rc != 0

    - name: Setup Cert-Manager CRDs
      command: kubectl apply --validate=false -f https://github.com/jetstack/cert-manager/releases/download/v0.15.0/cert-manager.crds.yaml

    - name: Check for Cert-Manager Namespace
      command: kubectl get namespace cert-manager
      register: cert_manager_namespace
      ignore_errors: True

    - name: Create Cert-Manager Namespace
      command: kubectl create namespace cert-manager
      when: cert_manager_namespace.rc != 0

    - name: Add Helm Repo
      command: helm repo add jetstack https://charts.jetstack.io

    - name: Update Helm Repo
      command: helm repo update

    - name: Check if cert-manager is already installed
      command: helm list -A -f cert-manager -q
      register: cert_manager_installed
    
    - name: Install cert-manager
      command: helm install cert-manager jetstack/cert-manager --namespace cert-manager --version v0.15.0
      register: cert_manager_install
      #when: cert_manager_installed == ""

    - name: Waiting for Cert-Manager to be fully up
      pause:
        prompt: "Waiting for Cert-Manager to become fully available"
        seconds: 180
      when: cert_manager_install.changed

    - name: Check if Rancher is already installed
      command: helm list --namespace cattle-system -f rancher -q
      register: rancher_installed

    - name: Install Rancher
      command: "helm install rancher rancher-latest/rancher --namespace cattle-system --set hostname=rancher.{{ arc['space']['space_domain'] }}" 
      #when: rancher_installed == ""